//
//  _MiscMergeFieldCommand.m
//            Written by Don Yacktman and Carl Lindberg
//        Copyright 1998 by Don Yacktman and Carl Lindberg.
//                     All rights reserved.
//      This notice may not be removed from this source code.
//
//	This header is included in the MiscKit by permission from the author
//	and its use is governed by the MiscKit license, found in the file
//	"License.rtf" in the MiscKit distribution.  Please refer to that file
//	for a list of all applicable permissions and restrictions.
//	

#import "_MiscMergeFieldCommand.h"
#import <MiscFoundation.subproj/NSString+MiscAdditions.h>
#import "NSScanner+MiscMerge.h"

@implementation _MiscMergeFieldCommand

- (void)dealloc
{
	[theField release];
	[super dealloc];
}

- (BOOL)parseFromScanner:(NSScanner *)aScanner template:(MiscMergeTemplate *)template
{
	if ([self eatKeyWord:@"field" fromScanner:aScanner isOptional:YES])
	{
		theField = [[[aScanner remainingString] stringByTrimmingLeadWhitespace] retain];
	}
	else
	{
		theField = [[aScanner string] retain];
	}

	return YES;
}

/*" Special method used by the template "*/
- (void)parseFromFieldName:(NSString *)fieldName
{
	theField = [fieldName retain];
}

- (void)executeForMerge:(MiscMergeEngine *)aMerger
{
	[aMerger appendToOutput:[aMerger valueForField:theField]];
}

@end
